Loading...
Searching...
No Matches
opengv::relative_pose::RelativeMultiAdapterBase Class Referenceabstract

`#include <RelativeMultiAdapterBase.hpp>`

Inheritance diagram for opengv::relative_pose::RelativeMultiAdapterBase:

## Public Member Functions

EIGEN_MAKE_ALIGNED_OPERATOR_NEW | RelativeMultiAdapterBase ()
| RelativeMultiAdapterBase (const rotation_t &R12)
| RelativeMultiAdapterBase (const translation_t &t12, const rotation_t &R12)
virtual | ~RelativeMultiAdapterBase ()
virtual bearingVector_t | getBearingVector1 (size_t pairIndex, size_t correspondenceIndex) const =0
| Retrieve the bearing vector of a correspondence in camera 1 of a pair.
virtual bearingVector_t | getBearingVector2 (size_t pairIndex, size_t correspondenceIndex) const =0
| Retrieve the bearing vector of a correspondence in camera 2 of a pair.
virtual double | getWeight (size_t pairIndex, size_t correspondenceIndex) const =0
| Retrieve the weight of a correspondence. The weight is supposed to reflect the quality of a correspondence, and typically is between 0 and 1.
virtual translation_t | getCamOffset (size_t pairIndex) const =0
| Retrieve the position of the cameras of a camera-pair seen from the origin of the viewpoints (assumed to be the same in both viewpoints).
virtual rotation_t | getCamRotation (size_t pairIndex) const =0
| Retrieve the rotation from the cameras of a camera-pair back to the origin of the viewpoints (assumed to be the same in both viewpoints).
virtual size_t | getNumberCorrespondences (size_t pairIndex) const =0
| Retrieve the number of correspondences for a camera-pair.
virtual size_t | getNumberPairs () const =0
| Retrieve the number of camera-pairs.
virtual std::vector< int > | convertMultiIndices (const std::vector< std::vector< int > > &multiIndices) const =0
| Convert an array of (pairIndex,correspondenceIndex)-pairs into an array of serialized indices.
virtual int | convertMultiIndex (size_t pairIndex, size_t correspondenceIndex) const =0
| Convert a (pairIndex,correspondenceIndex)-pair into a serialized index.
virtual int | multiPairIndex (size_t index) const =0
| Get the camera-pair-index corresponding to a serialized index.
virtual int | multiCorrespondenceIndex (size_t index) const =0
| Get the keypoint-index in a camera-pair for a serialized index.
virtual bearingVector_t | getBearingVector1 (size_t index) const
virtual bearingVector_t | getBearingVector2 (size_t index) const
virtual double | getWeight (size_t index) const
virtual translation_t | getCamOffset1 (size_t index) const
virtual rotation_t | getCamRotation1 (size_t index) const
virtual translation_t | getCamOffset2 (size_t index) const
virtual rotation_t | getCamRotation2 (size_t index) const
virtual size_t | getNumberCorrespondences () const
Public Member Functions inherited from opengv::relative_pose::RelativeAdapterBase
EIGEN_MAKE_ALIGNED_OPERATOR_NEW | RelativeAdapterBase ()
| Constructor.
| RelativeAdapterBase (const rotation_t &R12)
| Constructor.
| RelativeAdapterBase (const translation_t &t12, const rotation_t &R12)
| Constructor.
virtual | ~RelativeAdapterBase ()
| Destructor.
opengv::translation_t | gett12 () const
| Retrieve the prior or known value for the relative position.
void | sett12 (const opengv::translation_t &t12)
| Set the prior or known value for the relative position.
opengv::rotation_t | getR12 () const
| Retrieve the prior or known value for the relative rotation.
void | setR12 (const opengv::rotation_t &R12)
| Set the prior or known value for the relative rotation.

## Protected Attributes

opengv::translation_t | _t12
opengv::rotation_t | _R12
Protected Attributes inherited from opengv::relative_pose::RelativeAdapterBase
opengv::translation_t | _t12
opengv::rotation_t | _R12

## Detailed Description

See the documentation of RelativeAdapterBase to understand the meaning of a RelativeAdapter. RelativeMultiAdapterBase extends the interface of RelativeAdapterBase by an additional pair-index for referring to pairs of cameras. Intended for special central multi-viewpoint or non-central relative viewpoint problems, allowing "camera-pair"-wise grouping of correspondences. Derived classes need to implement functionalities for deriving unique serialization of multi-indices.

## Constructor & Destructor Documentation

## RelativeMultiAdapterBase() [1/3]

EIGEN_MAKE_ALIGNED_OPERATOR_NEW opengv::relative_pose::RelativeMultiAdapterBase::RelativeMultiAdapterBase | ( |  | ) |

inline

See parent-class

## RelativeMultiAdapterBase() [2/3]

opengv::relative_pose::RelativeMultiAdapterBase::RelativeMultiAdapterBase | ( | const rotation_t & | R12 | ) |

inline

See parent-class

## RelativeMultiAdapterBase() [3/3]

opengv::relative_pose::RelativeMultiAdapterBase::RelativeMultiAdapterBase | ( | const translation_t & | t12,
|  | const rotation_t & | R12 )

inline

See parent-class

## ~RelativeMultiAdapterBase()

virtual opengv::relative_pose::RelativeMultiAdapterBase::~RelativeMultiAdapterBase | ( |  | ) |

inline virtual

See parent-class

## Member Function Documentation

## convertMultiIndex()

virtual int opengv::relative_pose::RelativeMultiAdapterBase::convertMultiIndex | ( | size_t | pairIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Convert a (pairIndex,correspondenceIndex)-pair into a serialized index.

Parameters

  [in] | pairIndex | The index of the camera-pair.
  [in] | correspondenceIndex | The index of the keypoint in the camera-pair.

Returns
  Array of single serialized indices referring uniquely to (pairIndex,correspondenceIndex)-pairs.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## convertMultiIndices()

virtual std::vector< int > opengv::relative_pose::RelativeMultiAdapterBase::convertMultiIndices | ( | const std::vector< std::vector< int > > & | multiIndices | ) | const

pure virtual

Convert an array of (pairIndex,correspondenceIndex)-pairs into an array of serialized indices.

Parameters

  [in] | multiIndices | Array of (pairIndex,correspondenceIndex)-pairs.

Returns
  Array of single serialized indices referring uniquely to (pairIndex,correspondenceIndex)-pairs.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## getBearingVector1() [1/2]

virtual bearingVector_t opengv::relative_pose::RelativeMultiAdapterBase::getBearingVector1 | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getBearingVector1() [2/2]

virtual bearingVector_t opengv::relative_pose::RelativeMultiAdapterBase::getBearingVector1 | ( | size_t | pairIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Retrieve the bearing vector of a correspondence in camera 1 of a pair.

Parameters

  [in] | pairIndex | Index of the camera-pair.
  [in] | correspondenceIndex | Index of the correspondence in the camera-pair.

Returns
  The corresponding bearing vector.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## getBearingVector2() [1/2]

virtual bearingVector_t opengv::relative_pose::RelativeMultiAdapterBase::getBearingVector2 | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getBearingVector2() [2/2]

virtual bearingVector_t opengv::relative_pose::RelativeMultiAdapterBase::getBearingVector2 | ( | size_t | pairIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Retrieve the bearing vector of a correspondence in camera 2 of a pair.

Parameters

  [in] | pairIndex | Index of the camera-pair.
  [in] | correspondenceIndex | Index of the correspondence in the camera-pair.

Returns
  The corresponding bearing vector.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## getCamOffset()

virtual translation_t opengv::relative_pose::RelativeMultiAdapterBase::getCamOffset | ( | size_t | pairIndex | ) | const

pure virtual

Retrieve the position of the cameras of a camera-pair seen from the origin of the viewpoints (assumed to be the same in both viewpoints).

Parameters

  [in] | pairIndex | Index of the camera-pair.

Returns
  The position of the camera seen from the viewpoint origin.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## getCamOffset1()

virtual translation_t opengv::relative_pose::RelativeMultiAdapterBase::getCamOffset1 | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getCamOffset2()

virtual translation_t opengv::relative_pose::RelativeMultiAdapterBase::getCamOffset2 | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getCamRotation()

virtual rotation_t opengv::relative_pose::RelativeMultiAdapterBase::getCamRotation | ( | size_t | pairIndex | ) | const

pure virtual

Retrieve the rotation from the cameras of a camera-pair back to the origin of the viewpoints (assumed to be the same in both viewpoints).

Parameters

  [in] | pairIndex | Index of the camera-pair.

Returns
  The rotation from the camera back to the viewpoint origin.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## getCamRotation1()

virtual rotation_t opengv::relative_pose::RelativeMultiAdapterBase::getCamRotation1 | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getCamRotation2()

virtual rotation_t opengv::relative_pose::RelativeMultiAdapterBase::getCamRotation2 | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getNumberCorrespondences() [1/2]

virtual size_t opengv::relative_pose::RelativeMultiAdapterBase::getNumberCorrespondences | ( |  | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getNumberCorrespondences() [2/2]

virtual size_t opengv::relative_pose::RelativeMultiAdapterBase::getNumberCorrespondences | ( | size_t | pairIndex | ) | const

pure virtual

Retrieve the number of correspondences for a camera-pair.

Parameters

  [in] | pairIndex | Index of the camera-pair.

Returns
  The number of correspondences in this camera-pair.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## getNumberPairs()

virtual size_t opengv::relative_pose::RelativeMultiAdapterBase::getNumberPairs | ( |  | ) | const

pure virtual

Retrieve the number of camera-pairs.

Returns
  The number of camera-pairs.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## getWeight() [1/2]

virtual double opengv::relative_pose::RelativeMultiAdapterBase::getWeight | ( | size_t | index | ) | const

inline virtual

See parent-class (no need to overload)

Implements opengv::relative_pose::RelativeAdapterBase.

## getWeight() [2/2]

virtual double opengv::relative_pose::RelativeMultiAdapterBase::getWeight | ( | size_t | pairIndex,
|  | size_t | correspondenceIndex ) const

pure virtual

Retrieve the weight of a correspondence. The weight is supposed to reflect the quality of a correspondence, and typically is between 0 and 1.

Parameters

  [in] | pairIndex | Index of the camera-pair.
  [in] | correspondenceIndex | Index of the correspondence in the camera-pair.

Returns
  The corresponding weight.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## multiCorrespondenceIndex()

virtual int opengv::relative_pose::RelativeMultiAdapterBase::multiCorrespondenceIndex | ( | size_t | index | ) | const

pure virtual

Get the keypoint-index in a camera-pair for a serialized index.

Parameters

  [in] | index | The serialized index.

Returns
  The keyopint-index in the camera-pair.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## multiPairIndex()

virtual int opengv::relative_pose::RelativeMultiAdapterBase::multiPairIndex | ( | size_t | index | ) | const

pure virtual

Get the camera-pair-index corresponding to a serialized index.

Parameters

  [in] | index | The serialized index.

Returns
  The camera-pair index.

Implemented in opengv::relative_pose::CentralRelativeMultiAdapter, opengv::relative_pose::MANoncentralRelativeMulti, and opengv::relative_pose::NoncentralRelativeMultiAdapter.

## Member Data Documentation

## _R12

opengv::rotation_t opengv::relative_pose::RelativeAdapterBase::_R12

protected

Prior or known value for the rotation from viewpoint 2 back to viewpoint 1. Initialized to identity if not provided.

## _t12

opengv::translation_t opengv::relative_pose::RelativeAdapterBase::_t12

protected

Prior or known value for the position of viewpoint 2 seen from viewpoint 1. Initialized to zero if not provided.

The documentation for this class was generated from the following file:

- include/opengv/relative_pose/RelativeMultiAdapterBase.hpp